"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const worker_threads_1 = require("worker_threads");
const parse_json_with_functions_1 = require("./parse-json-with-functions");
const stringify_json_with_functions_1 = require("./stringify-json-with-functions");
const workerData = worker_threads_1.workerData;
async function execute() {
    const context = (0, parse_json_with_functions_1.parseJSONWithFunctions)(workerData.context);
    const script = await Promise.resolve().then(() => __importStar(require(workerData.file)));
    const results = [];
    for (let i = 0; i < workerData.samples; i++) {
        performance.mark("start");
        const result = await script.default(context);
        performance.mark("end");
        results.push(result);
        performance.measure(workerData.id, "start", "end");
    }
    const measures = performance.getEntriesByName(workerData.id);
    return { results, measures };
}
execute().then(({ results, measures }) => {
    worker_threads_1.parentPort?.postMessage((0, stringify_json_with_functions_1.stringifyJSONWithFunctions)({
        id: workerData.id,
        results,
        measures,
    }));
});
